## cmocka 1.1.3

=== CMakeLists.txt ===
# Required cmake version
cmake_minimum_required(VERSION 3.5.0)
cmake_policy(SET CMP0048 NEW)

# Specify search path for CMake modules to be loaded by include() 
# and find_package()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")

### Add defaults for cmake
# These defaults need to be included before the project() call.
include(DefineCMakeDefaults)

# This will provide -DCMAKE_BUILD_TYPE=Profiling
# and -DCMAKE_BUILD_TYPE=AddressSanitizer
include(DefineCompilerFlags)
include(DefinePlatformDefaults)

project(cmocka VERSION 1.1.3 LANGUAGES C)

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

# SOVERSION scheme: CURRENT.AGE.REVISION
#   If there was an incompatible interface change:
#     Increment CURRENT. Set AGE and REVISION to 0
#   If there was a compatible interface change:
#     Increment AGE. Set REVISION to 0
#   If the source code was changed, but there were no interface changes:
#     Increment REVISION.
set(LIBRARY_VERSION "0.5.1")
set(LIBRARY_SOVERSION "0")

# include cmake files
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(DefineOptions.cmake)
include(CPackConfig.cmake)
include(CompilerChecks.cmake)

# disallow in-source build
include(MacroEnsureOutOfSourceBuild)
macro_ensure_out_of_source_build("${PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# MinGW DLL Naming Workaround
if (MINGW)
    set(CMAKE_SHARED_LIBRARY_PREFIX "")
endif (MINGW)

# check subdirectories
add_subdirectory(doc)
add_subdirectory(include)
add_subdirectory(src)

include(AddCMockaTest)
if (UNIT_TESTING)
    add_subdirectory(tests)
endif (UNIT_TESTING)

add_subdirectory(example)

# pkg-config file
configure_file(cmocka.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/cmocka.pc)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/cmocka.pc
  DESTINATION
  ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  COMPONENT
    pkgconfig
)

# cmake config files
set(CMOCKA_LIBRARY_NAME ${CMAKE_SHARED_LIBRARY_PREFIX}${PROJECT_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX})

set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR} CACHE INTERNAL "")
set(LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR} CACHE INTERNAL "")
configure_package_config_file(${PROJECT_NAME}-config.cmake.in
                              ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake
                              PATH_VARS
                                  INCLUDE_INSTALL_DIR LIB_INSTALL_DIR
                              INSTALL_DESTINATION
                                  ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

write_basic_package_version_file(${PROJECT_NAME}-config-version.cmake
                                 COMPATIBILITY
                                     AnyNewerVersion)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
    DESTINATION
        ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
    COMPONENT
        devel
)

# Add 'make dist' target which makes sure to invoke cmake before
add_custom_target(dist
                  COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

=== doc/CMakeLists.txt ===
#
# Build the documentation
#
if (${CMAKE_VERSION} VERSION_GREATER "3.8.99")

find_package(Doxygen)

if (DOXYGEN_FOUND)
    set(DOXYGEN_PROJECT_NAME ${PROJECT_NAME})
    set(DOXYGEN_PROJECT_NUMBER ${PROJECT_VERSION})
    set(DOXYGEN_PROJECT_BRIEF "Unit testing library with mock support")

    set(DOXYGEN_TAB_SIZE 4)
    set(DOXYGEN_OPTIMIZE_OUTPUT_FOR_C YES)
    set(DOXYGEN_MARKDOWN_SUPPORT YES)

    set(DOXYGEN_PREDEFINED DOXYGEN
                           CMOCKA_PRINTF_ATTRIBUTE(x,y))

    set(DOXYGEN_EXCLUDE ${CMAKE_CURRENT_SOURCE_DIR}/that_style)
    set(DOXYGEN_HTML_HEADER ${CMAKE_CURRENT_SOURCE_DIR}/that_style/header.html)
    set(DOXYGEN_HTML_EXTRA_STYLESHEET ${CMAKE_CURRENT_SOURCE_DIR}/that_style/that_style.css)
    set(DOXYGEN_HTML_EXTRA_FILES ${CMAKE_CURRENT_SOURCE_DIR}/that_style/img/nav_edge_left.svg
                                 ${CMAKE_CURRENT_SOURCE_DIR}/that_style/img/nav_edge_right.svg
                                 ${CMAKE_CURRENT_SOURCE_DIR}/that_style/img/nav_edge_inter.svg
                                 ${CMAKE_CURRENT_SOURCE_DIR}/that_style/img/sync_off.png
                                 ${CMAKE_CURRENT_SOURCE_DIR}/that_style/img/sync_on.png
                                 ${CMAKE_CURRENT_SOURCE_DIR}/that_style/img/splitbar_handle.svg
                                 ${CMAKE_CURRENT_SOURCE_DIR}/that_style/img/doc.svg
                                 ${CMAKE_CURRENT_SOURCE_DIR}/that_style/img/mag_glass.svg
                                 ${CMAKE_CURRENT_SOURCE_DIR}/that_style/img/folderclosed.svg
                                 ${CMAKE_CURRENT_SOURCE_DIR}/that_style/img/folderopen.svg
                                 ${CMAKE_CURRENT_SOURCE_DIR}/that_style/js/striped_bg.js)

    set(_doxyfile_template "${CMAKE_BINARY_DIR}/CMakeDoxyfile.in")
    set(_target_doxyfile "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile.docs")
    configure_file("${_doxyfile_template}" "${_target_doxyfile}")

    doxygen_add_docs(docs
                     ${cmocka-library_SOURCE_DIR}
                     ${cmocka-headers_SOURCE_DIR}
                     ${CMAKE_CURRENT_SOURCE_DIR})
endif(DOXYGEN_FOUND)

endif() # CMAKE_VERSION

=== src/CMakeLists.txt ===
project(cmocka-library C)

set(CMOCKA_PLATFORM_INCLUDE CACHE PATH "Path to include directory for cmocka_platform.h")
mark_as_advanced(CMOCKA_PLATFORM_INCLUDE)

set(CMOCKA_SHARED_LIBRARY
    cmocka
    CACHE INTERNAL "cmocka shared library"
)

if (BUILD_STATIC_LIB)
    set(CMOCKA_STATIC_LIBRARY
        cmocka-static
        CACHE INTERNAL "cmocka static library"
    )
endif()

set(CMOCKA_LINK_LIBRARIES
    ${CMOCKA_REQUIRED_LIBRARIES}
    CACHE INTERNAL "cmocka link libraries"
)

set(cmocka_SRCS
    cmocka.c
)

if (WIN32)
    set(cmocka_SRCS
        ${cmocka_SRCS}
        cmocka.def
    )
endif (WIN32)

add_library(${CMOCKA_SHARED_LIBRARY} SHARED ${cmocka_SRCS})

target_include_directories(${CMOCKA_SHARED_LIBRARY}
                           PRIVATE
                               ${CMOCKA_PLATFORM_INCLUDE}
                               ${cmocka_BINARY_DIR}
                           PUBLIC
                               ${cmocka-header_SOURCE_DIR})


target_compile_options(${CMOCKA_SHARED_LIBRARY}
                       PRIVATE
                           ${DEFAULT_C_COMPILE_FLAGS}
                           -DHAVE_CONFIG_H)
if (CMOCKA_PLATFORM_INCLUDE)
    target_compile_options(${CMOCKA_SHARED_LIBRARY}
                           PRIVATE
                               -DCMOCKA_PLATFORM_INCLUDE)
endif()

target_link_libraries(${CMOCKA_SHARED_LIBRARY} ${CMOCKA_LINK_LIBRARIES})
set_property(TARGET
                 ${CMOCKA_SHARED_LIBRARY}
             PROPERTY
                 DEFINE_SYMBOL
                     CMOCKA_EXPORTS
             PROPERTY
                 LINKER_FLAGS
                     "${DEFAULT_LINK_FLAGS}")

if (NOT WIN32)
    set_target_properties(
        ${CMOCKA_SHARED_LIBRARY}
            PROPERTIES
                VERSION
                    ${LIBRARY_VERSION}
                SOVERSION
                    ${LIBRARY_SOVERSION}
    )
endif (NOT WIN32)

install(TARGETS
            ${CMOCKA_SHARED_LIBRARY}
        ARCHIVE DESTINATION
            ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION
            ${CMAKE_INSTALL_LIBDIR}
        COMPONENT
            ${PROJECT_NAME})

if (BUILD_STATIC_LIB)
    add_library(${CMOCKA_STATIC_LIBRARY} STATIC ${cmocka_SRCS})

    target_include_directories(${CMOCKA_STATIC_LIBRARY}
                               PRIVATE
                                   ${CMOCKA_PLATFORM_INCLUDE}
                                   ${cmocka_BINARY_DIR}
                               PUBLIC
                                   ${cmocka-header_SOURCE_DIR})

    target_compile_options(${CMOCKA_STATIC_LIBRARY}
                           PRIVATE
                               ${DEFAULT_C_COMPILE_FLAGS}
                               -DHAVE_CONFIG_H)
    if (CMOCKA_PLATFORM_INCLUDE)
        target_compile_options(${CMOCKA_STATIC_LIBRARY}
                               PRIVATE
                                   -DCMOCKA_PLATFORM_INCLUDE)
    endif()

    set_property(TARGET
                     ${CMOCKA_STATIC_LIBRARY}
                 PROPERTY
                     DEFINE_SYMBOL
                         CMOCKA_EXPORTS
                 PROPERTY
                     LINK_FLAGS
                        "${DEFAULT_LINK_FLAGS}")

    if (WITH_STATIC_LIB)
        install(TARGETS
                    ${CMOCKA_STATIC_LIBRARY}
                ARCHIVE DESTINATION
                    ${CMAKE_INSTALL_LIBDIR}
                COMPONENT
                    ${PROJECT_NAME})
    endif()
endif (BUILD_STATIC_LIB)

=== tests/CMakeLists.txt ===
project(tests C)

set(TEST_EXCEPTION_HANDLER TRUE)
if (CMAKE_BUILD_TYPE)
    string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
    if (CMAKE_BUILD_TYPE_LOWER STREQUAL "undefinedsanitizer")
        set(TEST_EXCEPTION_HANDLER FALSE)
    endif()
endif()

set(CMOCKA_TESTS
    test_alloc
    test_group_setup_assert
    test_group_setup_fail
    test_fixtures
    test_group_fixtures
    test_groups
    test_assert_macros
    test_assert_macros_fail
    test_basics
    test_skip
    test_strmatch
    test_setup_fail
    test_ordering
    test_ordering_fail
    test_returns
    test_returns_fail
    test_wildcard)

if (TEST_EXCEPTION_HANDLER)
    list(APPEND CMOCKA_TESTS test_exception_handler)
endif()

foreach(_CMOCKA_TEST ${CMOCKA_TESTS})
    add_cmocka_test(${_CMOCKA_TEST}
                    SOURCES ${_CMOCKA_TEST}.c
                    COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS}
                    LINK_LIBRARIES ${CMOCKA_STATIC_LIBRARY}
                    LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
    target_include_directories(${_CMOCKA_TEST} PRIVATE ${cmocka_BINARY_DIR})
endforeach()

### Special Cases
if (${CMAKE_C_COMPILER_ID} MATCHES "(GNU|Clang)")
    set_source_files_properties(test_cmockery.c PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations")
endif()
add_cmocka_test(test_cmockery
                SOURCES test_cmockery.c
                COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS}
                LINK_LIBRARIES ${CMOCKA_STATIC_LIBRARY}
                LINK_OPTIONS ${DEFAULT_LINK_FLAGS})

### Exceptions

# test_skip
set_tests_properties(
    test_skip
        PROPERTIES
        PASS_REGULAR_EXPRESSION
        "\\[  SKIPPED \\] test_check_skip"
)

# test_assert_macros_fail
set_tests_properties(
    test_assert_macros_fail
        PROPERTIES
        PASS_REGULAR_EXPRESSION
        "\\[  FAILED  \\] 1 test"
)

# test_ordering ensure proper failures
set_tests_properties(
    test_ordering_fail
        PROPERTIES
        PASS_REGULAR_EXPRESSION
        "\\[  FAILED  \\] 7 test"
)

# test_returns_fail ensure proper failures
set_tests_properties(
    test_returns_fail
        PROPERTIES
        PASS_REGULAR_EXPRESSION
        "\\[  FAILED  \\] 3 test"
)

# test_exception_handler
if (TEST_EXCEPTION_HANDLER)
    if (WIN32)
        set_tests_properties(test_exception_handler
                                 PROPERTIES
                                     PASS_REGULAR_EXPRESSION
                                         "EXCEPTION_ACCESS_VIOLATION occurred at")
    else()
        set_tests_properties(test_exception_handler
                             PROPERTIES
                                 PASS_REGULAR_EXPRESSION
                                     "Test failed with exception: (Segmentation fault|Segmentation Fault|11|Illegal instruction)")
    endif (WIN32)
endif (TEST_EXCEPTION_HANDLER)

set_tests_properties(
    test_setup_fail
        PROPERTIES
        WILL_FAIL
        1
)

set_tests_properties(
    test_group_setup_assert
        PROPERTIES
        WILL_FAIL
        1
)

set_tests_properties(
    test_group_setup_fail
        PROPERTIES
        WILL_FAIL
        1
)

add_test(test_setup_fail_1_failed ${TARGET_SYSTEM_EMULATOR} test_setup_fail)
set_tests_properties(
    test_setup_fail_1_failed
        PROPERTIES
        PASS_REGULAR_EXPRESSION
        "\\[  ERROR   \\] int_test_ignored"
)

add_test (test_setup_fail_1_passed ${TARGET_SYSTEM_EMULATOR} test_setup_fail)
set_tests_properties(
    test_setup_fail_1_passed
        PROPERTIES
        PASS_REGULAR_EXPRESSION
        "\\[  PASSED  \\] 1 test\\(s\\)."
)

add_test (test_setup_fail_match_failed ${TARGET_SYSTEM_EMULATOR} test_setup_fail)
set_tests_properties(
    test_setup_fail_match_failed
        PROPERTIES
        PASS_REGULAR_EXPRESSION
        "\\[  ERROR   \\] int_test_ignored"
)

add_test (test_setup_fail_match_passed ${TARGET_SYSTEM_EMULATOR} test_setup_fail)
set_tests_properties(
    test_setup_fail_match_passed
        PROPERTIES
        PASS_REGULAR_EXPRESSION
        "\\[       OK \\] int_test_success"
)

### Output formats

# test output of success, failure, skip, fixture failure
set(OUTPUT_TESTS
    test_basics
    test_assert_macros_fail
    test_groups
    test_skip
    test_setup_fail)

set(TEST_OUTPUT_FMTS
    tap
    subunit
    xml)

set(test_basics_tap_out
    "^1\\.\\.2"
    "ok 1 - null_test_success"
    "ok 2 - int_test_success"
    "# ok - tests")
set(test_assert_macros_fail_tap_out
    "^1\\.\\.1"
    "not ok 1 - test_assert_return_code_fail"
    "#[^\n\r]+[\n\r]#[^\n\r]+[\n\r]# not ok - tests")
set(test_groups_tap_out
    "^1\\.\\.1"
    "ok 1 - null_test_success"
    "# ok - test_group1"
    "1\\.\\.1"
    "ok 1 - int_test_success"
    "# ok - test_group2")
set(test_skip_tap_out
    "not ok 1 # SKIP")
set(test_setup_fail_tap_out
    "not ok 1 - int_test_ignored Could not run test: Test setup failed")

set(test_basics_subunit_out
    "^test: null_test_success"
    "success: null_test_success")
set(test_assert_macros_fail_subunit_out
    "failure: test_assert_return_code_fail \\[")
set(test_groups_subunit_out
    "^test: null_test_success"
    "success: null_test_success")
set(test_skip_subunit_out
    "^test: test_check_skip"
    "skip: test_check_skip")
set(test_setup_fail_subunit_out
    "error: int_test_ignored \\[ Could not run test: Test setup failed \\]")

set(test_basics_xml_out
    "<testsuite name=\"tests\" time=\"[0-9.]+\" tests=\"2\" failures=\"0\" errors=\"0\" skipped=\"0\" >"
    "<testcase name=\"null_test_success\" time=\"[0-9.]+\" >.*</testcase>")
set(test_assert_macros_fail_xml_out
    "<testcase name=\"test_assert_return_code_fail\" time=\"[0-9.]+\" >"
    "<failure>")
set(test_groups_xml_out
    "^<\\?xml version=\"1.0\" encoding=\"UTF-8\" \\?>"
    "<testsuites>"
    "<testsuite name=\"test_group1\" time=\"[0-9.]+\" tests=\"1\" failures=\"0\" errors=\"0\" skipped=\"0\" >"
    "<testcase name=\"null_test_success\" time=\"[0-9.]+\" >"
    "</testcase>"
    "</testsuite>"
    ".*<testsuite name=\"test_group2\" time=\"[0-9.]+\" tests=\"1\" failures=\"0\" errors=\"0\" skipped=\"0\" >"
    "<testcase name=\"int_test_success\" time=\"[0-9.]+\" >"
    "</testcase>"
    "</testsuite>"
    "</testsuites>")
set(test_skip_xml_out
    "<testcase name=\"test_check_skip\" time=\"[0-9.]+\" >"
    "<skipped/>")
set(test_setup_fail_xml_out
    "<testcase name=\"int_test_ignored\" time=\"[0-9.]+\" >"
    "<failure><!\\[CDATA\\[Test setup failed\\]\\]></failure>")

foreach(_TEST_OUTPUT_FMT ${TEST_OUTPUT_FMTS})
    foreach(_OUTPUT_TEST ${OUTPUT_TESTS})
        set(TEST_NAME ${_OUTPUT_TEST}_${_TEST_OUTPUT_FMT})
        add_test(${TEST_NAME} ${TARGET_SYSTEM_EMULATOR} ${_OUTPUT_TEST})

        set_property(
            TEST
            ${TEST_NAME}
            PROPERTY
                ENVIRONMENT CMOCKA_MESSAGE_OUTPUT=${_TEST_OUTPUT_FMT}
            )

        list(LENGTH ${TEST_NAME}_out len)
        list(GET ${TEST_NAME}_out 0 output)
        if(len GREATER 1)
            list(REMOVE_AT ${TEST_NAME}_out 0)
            foreach(line ${${TEST_NAME}_out})
                set(output "${output}[ \n\r]+${line}")
            endforeach()
        endif()

        set_tests_properties(
            ${TEST_NAME}
            PROPERTIES
            PASS_REGULAR_EXPRESSION
            ${output}
        )
    endforeach()
endforeach()

=== example/mock/chef_wrap/CMakeLists.txt ===
project(cmocka-wrap-examples C)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMOCKA_PUBLIC_INCLUDE_DIRS}
)

add_executable(waiter_test_wrap waiter_test_wrap.c chef.c)
target_link_libraries(waiter_test_wrap ${CMOCKA_SHARED_LIBRARY})

add_test(waiter_test_wrap ${CMAKE_CURRENT_BINARY_DIR}/waiter_test_wrap)

set_target_properties(waiter_test_wrap
        PROPERTIES
        LINK_FLAGS  "-Wl,--wrap=chef_cook"
)
if (WIN32 OR MINGW OR CYGWIN)
    set_tests_properties(waiter_test_wrap PROPERTIES ENVIRONMENT "PATH=${DLL_PATH_ENV}")
endif (WIN32 OR MINGW OR CYGWIN)

=== example/mock/uptime/CMakeLists.txt ===
add_library(proc_uptime proc_uptime.c)

add_executable(uptime uptime.c)
target_compile_options(uptime PRIVATE ${DEFAULT_C_COMPILE_FLAGS})
target_link_libraries(uptime proc_uptime)
set_property(TARGET
                 uptime
             PROPERTY
                 LINK_FLAGS
                     "${DEFAULT_LINK_FLAGS}")

add_cmocka_test(test_uptime
                SOURCES test_uptime.c
                COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS}
                LINK_LIBRARIES ${CMOCKA_SHARED_LIBRARY})
set_property(TARGET
                 test_uptime
             PROPERTY
                 LINK_FLAGS
                    "${DEFAULT_LINK_FLAGS} -Wl,--wrap=uptime")

=== debian/changelog ===
cmocka (1.1.3-1) unstable; urgency=medium

  [ Andreas Schneider ]
  * Bump version to 1.1.3

  [ David Prévot ]
  * Use debhelper-compat 11
  * Drop get-orig-source target
  * Declare minimum required cmake version (Closes: #908385)
  * Update copyright
  * Drop static libraries not built anymore

 -- David Prévot <taffit@debian.org>  Fri, 28 Sep 2018 17:43:00 -1000

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --list-missing

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
		-DWITH_CMOCKERY_SUPPORT=ON \
		-DUNIT_TESTING=ON

override_dh_auto_build-indep:
	$(MAKE) -C obj-* docs

override_dh_auto_test-indep:

override_dh_link-arch:
	dh_link usr/lib/$(DEB_HOST_MULTIARCH)/libcmocka.so \
		usr/lib/$(DEB_HOST_MULTIARCH)/libcmockery.so \
		-plibcmocka-dev

override_dh_auto_install-indep:
	dh_install obj-*/doc/html usr/share/doc/cmocka-doc
	dh_doxygen

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s%$%.asc%" \
https://cmocka.org/files/([\d.]+)/cmocka-(.*).tar.xz

## cmocka 1.1.5

=== example/CMakeLists.txt ===
project(cmocka-examples C)

function(ADD_CMOCKA_TEST_ENVIRONMENT _TARGET_NAME)
    if (WIN32 OR CYGWIN OR MINGW)
        file(TO_NATIVE_PATH "${cmocka-library_BINARY_DIR}" CMOCKA_DLL_PATH)

        if (TARGET_SYSTEM_EMULATOR)
            set(DLL_PATH_ENV "WINEPATH=${CMOCKA_DLL_PATH};$ENV{WINEPATH}")
        else()
            set(DLL_PATH_ENV "PATH=${CMOCKA_DLL_PATH};$ENV{PATH}")
        endif()
        #
        # IMPORTANT NOTE: The set_tests_properties(), below, internally
        # stores its name/value pairs with a semicolon delimiter.
        # because of this we must protect the semicolons in the path
        #
        string(REPLACE ";" "\\;" DLL_PATH_ENV "${DLL_PATH_ENV}")

        set_tests_properties(${_TARGET_NAME}
                             PROPERTIES
                                ENVIRONMENT
                                    "${DLL_PATH_ENV}")
    endif()
endfunction()

set_source_files_properties(calculator.c
                            allocate_module.c
                            assert_module.c
                            PROPERTIES
                                COMPILE_DEFINITIONS
                                    UNIT_TESTING=1)


### The most simple test
add_cmocka_test(simple_test
                SOURCES simple_test.c
                COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS}
                LINK_LIBRARIES ${CMOCKA_SHARED_LIBRARY})
add_cmocka_test_environment(simple_test)

### Allocate module test
add_cmocka_test(allocate_module_test
                SOURCES allocate_module.c allocate_module_test.c
                LINK_LIBRARIES ${CMOCKA_SHARED_LIBRARY})
add_cmocka_test_environment(allocate_module_test)

set_tests_properties(allocate_module_test
                     PROPERTIES
                        WILL_FAIL 1)

### Assert macro test
add_cmocka_test(assert_macro_test
                SOURCES assert_macro.c assert_macro_test.c
                LINK_LIBRARIES ${CMOCKA_SHARED_LIBRARY})
add_cmocka_test_environment(assert_macro_test)

set_tests_properties(assert_macro_test
                     PROPERTIES
                        WILL_FAIL 1)

### Assert module test
add_cmocka_test(assert_module_test
                SOURCES assert_module.c assert_module_test.c
                LINK_LIBRARIES ${CMOCKA_SHARED_LIBRARY})
add_cmocka_test_environment(assert_module_test)

set_tests_properties(assert_module_test
                     PROPERTIES
                        WILL_FAIL 1)

if (NOT WIN32)
    add_subdirectory(mock)
endif()

=== include/CMakeLists.txt ===
project(cmocka-header C)

install(FILES
            cmocka.h
            cmocka_pbc.h
        DESTINATION
            ${CMAKE_INSTALL_INCLUDEDIR}
        COMPONENT
            ${PROJECT_NAME})

if (WITH_CMOCKERY_SUPPORT)
    install(FILES
                cmockery/cmockery.h
                cmockery/pbc.h
            DESTINATION
                ${CMAKE_INSTALL_INCLUDEDIR}/cmockery
            COMPONENT
                ${PROJECT_NAME})
endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
     test_fixtures
     test_group_fixtures
     test_groups
+    test_float_macros
     test_assert_macros
     test_assert_macros_fail
     test_basics
@@ -25,7 +26,9 @@
     test_ordering_fail
     test_returns
     test_returns_fail
-    test_wildcard)
+    test_wildcard
+    test_skip_filter
+    )
 
 if (TEST_EXCEPTION_HANDLER)
     list(APPEND CMOCKA_TESTS test_exception_handler)

=== debian/changelog ===
cmocka (1.1.5-2.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster
  * Bump debhelper from old 12 to 13.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * Update standards version to 4.6.0, no changes needed.
  * Fix field name case in debian/control (Build-Depends-indep =>
    Build-Depends-Indep).

  [ Vagrant Cascadian ]
  * debian/patches: Disable embedding of full path names in documentation
    generated by doxygen. (Closes: #991181)

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Thu, 29 Dec 2022 10:55:47 -0800

cmocka (1.1.5-2) unstable; urgency=medium

  * Upload to unstable now that buster has been released
  * Update standards version, no changes needed.
  * Set upstream metadata fields: Contact, Name.

 -- David Prévot <taffit@debian.org>  Sat, 10 Aug 2019 17:34:42 -1000

cmocka (1.1.5-1) experimental; urgency=medium

  * Upload to experimental during the freeze

  [ Andreas Schneider ]
  * Bump version to 1.1.5

  [ David Prévot ]
  * Use debhelper-compat 12
  * Update Standards-Version to 4.3.0
  * Update copyright

 -- David Prévot <taffit@debian.org>  Sun, 31 Mar 2019 21:45:18 -1000

=== debian/control ===
Source: cmocka
Section: devel
Priority: optional
Maintainer: David Prévot <taffit@debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>
Build-Depends: cmake, debhelper-compat (= 13)
Standards-Version: 4.6.0
Homepage: https://cmocka.org/
Vcs-Git: https://salsa.debian.org/debian/cmocka.git
Vcs-Browser: https://salsa.debian.org/debian/cmocka
Build-Depends-Indep: doxygen

Package: cmocka-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, ${misc:Depends}
Description: documentation for the CMocka unit testing framework
 This package contains the documentation and examples for CMocka.
 .
 The idea of CMocka is that a test application only requires the
 standard C library and the CMocka library itself to minimize conflicts
 with standard C headers especially on a lot of different platforms.
 .
 Features:
  * Easy to use framework to write unit tests
  * Support for mock objects
  * Testing of memory leaks, buffer overflows and underflows
  * Platform and compiler independent

Package: libcmocka0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library for the CMocka unit testing framework
 This is the major library for CMocka.
 .
 The idea of CMocka is that a test application only requires the
 standard C library and the CMocka library itself to minimize conflicts
 with standard C headers especially on a lot of different platforms.
 .
 Features:
  * Easy to use framework to write unit tests
  * Support for mock objects
  * Testing of memory leaks, buffer overflows and underflows
  * Platform and compiler independent

Package: libcmocka-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcmocka0 (= ${binary:Version}), ${misc:Depends}
Recommends: cmocka-doc
Description: development files for the CMocka unit testing framework
 This package contains the library development files for CMocka.
 .
 The idea of CMocka is that a test application only requires the
 standard C library and the CMocka library itself to minimize conflicts
 with standard C headers especially on a lot of different platforms.
 .
 Features:
  * Easy to use framework to write unit tests
  * Support for mock objects
  * Testing of memory leaks, buffer overflows and underflows
  * Platform and compiler independent

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 include /usr/share/dpkg/buildflags.mk
 
 %:
-	dh $@ --list-missing
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \

## cmocka 1.1.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 include(DefineCompilerFlags)
 include(DefinePlatformDefaults)
 
-project(cmocka VERSION 1.1.3 LANGUAGES C)
+project(cmocka VERSION 1.1.7 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
@@ -27,7 +27,7 @@
 #     Increment AGE. Set REVISION to 0
 #   If the source code was changed, but there were no interface changes:
 #     Increment REVISION.
-set(LIBRARY_VERSION "0.5.1")
+set(LIBRARY_VERSION "0.8.0")
 set(LIBRARY_SOVERSION "0")
 
 # include cmake files
@@ -51,19 +51,21 @@
 endif (MINGW)
 
 # check subdirectories
-add_subdirectory(doc)
 add_subdirectory(include)
 add_subdirectory(src)
+add_subdirectory(doc)
 
 include(AddCMockaTest)
 if (UNIT_TESTING)
     add_subdirectory(tests)
 endif (UNIT_TESTING)
 
-add_subdirectory(example)
+if (WITH_EXAMPLES)
+    add_subdirectory(example)
+endif ()
 
 # pkg-config file
-configure_file(cmocka.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/cmocka.pc)
+configure_file(cmocka.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/cmocka.pc @ONLY)
 install(
   FILES
     ${CMAKE_CURRENT_BINARY_DIR}/cmocka.pc
@@ -73,32 +75,19 @@
     pkgconfig
 )
 
-# cmake config files
-set(CMOCKA_LIBRARY_NAME ${CMAKE_SHARED_LIBRARY_PREFIX}${PROJECT_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX})
-
-set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR} CACHE INTERNAL "")
-set(LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR} CACHE INTERNAL "")
-configure_package_config_file(${PROJECT_NAME}-config.cmake.in
-                              ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake
-                              PATH_VARS
-                                  INCLUDE_INSTALL_DIR LIB_INSTALL_DIR
-                              INSTALL_DESTINATION
-                                  ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
-
 write_basic_package_version_file(${PROJECT_NAME}-config-version.cmake
                                  COMPATIBILITY
                                      AnyNewerVersion)
 
-install(
-    FILES
-        ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake
-        ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
-    DESTINATION
-        ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
-    COMPONENT
-        devel
-)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
+        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
+        COMPONENT devel)
 
 # Add 'make dist' target which makes sure to invoke cmake before
 add_custom_target(dist
                   COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
+
+# Link combile database for clangd
+execute_process(COMMAND cmake -E create_symlink
+                "${cmocka_BINARY_DIR}/compile_commands.json"
+                "${cmocka_SOURCE_DIR}/compile_commands.json")

=== example/mock/uptime/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 add_cmocka_test(test_uptime
                 SOURCES test_uptime.c
                 COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS}
-                LINK_LIBRARIES ${CMOCKA_SHARED_LIBRARY})
+                LINK_LIBRARIES cmocka::cmocka)
 set_property(TARGET
                  test_uptime
              PROPERTY

=== debian/changelog ===
cmocka (1.1.7-3) unstable; urgency=medium

  * Add patch to set CMOCKA_LIBRARIES (Closes: #1060177, #1060178, #1060179,
    #1060178).

 -- Sandro Knauß <hefee@debian.org>  Sun, 07 Jan 2024 10:27:53 +0100

cmocka (1.1.7-2) unstable; urgency=medium

  + Upload to unstable.
  * Disable lto as it fails (#1015370).

 -- Sandro Knauß <hefee@debian.org>  Tue, 19 Dec 2023 15:39:17 +0100

cmocka (1.1.7-1) experimental; urgency=medium

  [ Andreas Schneider ]
  * cpack: Update ignore files for source package generation
  * Bump version to 1.1.7

 -- David Prévot <taffit@debian.org>  Fri, 24 Feb 2023 06:01:43 +0100

cmocka (1.1.6-1) experimental; urgency=medium

  * Upload to experimental during the freeze

  [ Dima Krasner ]
  * meson: Initial Meson build system support

  [ Arnaud Gelas ]
  * cmocka: Add new assert macros to compare 2 double given an epsilon.

  [ Paolo Teti ]
  * Fix possible loss of data reported by MSVC
  * Fix MSVC warning on conversion from 'time_t' to 'double'

  [ Andreas Schneider ]
  * include: Update copyright year info
  * Bump version 1.1.6

  [ Matthias Schiffer ]
  * Fix TAP output for skipped tests

  [ Sergey Bronnikov ]
  * cmocka: add header with version to TAP13 output

  [ Ammar Ratnani ]
  * Fix issue with fail_msg

  [ David Prévot ]
  * Add debian/gbp.conf
  * Update copyright (years)
  * Set upstream metadata fields: Repository.
  * Update standards version to 4.6.2, no changes needed.
  * Set Rules-Requires-Root: no.
  * Update symbols

 -- David Prévot <taffit@debian.org>  Fri, 17 Feb 2023 22:12:16 +0100

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,12 @@
 Maintainer: David Prévot <taffit@debian.org>
 Uploaders: Sandro Knauß <hefee@debian.org>
 Build-Depends: cmake, debhelper-compat (= 13)
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://cmocka.org/
 Vcs-Git: https://salsa.debian.org/debian/cmocka.git
 Vcs-Browser: https://salsa.debian.org/debian/cmocka
 Build-Depends-Indep: doxygen
+Rules-Requires-Root: no
 
 Package: cmocka-doc
 Section: doc

## cmocka 1.1.8

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,10 @@
 project(tests C)
 
 set(TEST_EXCEPTION_HANDLER TRUE)
+if (WIN32)
+    # FIXME: The exception handler doesn't work on Windows
+    set(TEST_EXCEPTION_HANDLER FALSE)
+endif()
 if (CMAKE_BUILD_TYPE)
     string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
     if (CMAKE_BUILD_TYPE_LOWER STREQUAL "undefinedsanitizer")
@@ -16,18 +20,22 @@
     test_group_fixtures
     test_groups
     test_float_macros
+    test_double_macros
     test_assert_macros
     test_assert_macros_fail
     test_basics
     test_skip
     test_strmatch
+    test_strreplace
     test_setup_fail
     test_ordering
     test_ordering_fail
     test_returns
     test_returns_fail
+    test_string
     test_wildcard
     test_skip_filter
+    test_cmockery
     )
 
 if (TEST_EXCEPTION_HANDLER)
@@ -38,20 +46,17 @@
     add_cmocka_test(${_CMOCKA_TEST}
                     SOURCES ${_CMOCKA_TEST}.c
                     COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS}
-                    LINK_LIBRARIES ${CMOCKA_STATIC_LIBRARY}
+                    LINK_LIBRARIES cmocka::static
                     LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
     target_include_directories(${_CMOCKA_TEST} PRIVATE ${cmocka_BINARY_DIR})
+
+    add_cmocka_test_environment(${_CMOCKA_TEST})
 endforeach()
 
 ### Special Cases
 if (${CMAKE_C_COMPILER_ID} MATCHES "(GNU|Clang)")
     set_source_files_properties(test_cmockery.c PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations")
 endif()
-add_cmocka_test(test_cmockery
-                SOURCES test_cmockery.c
-                COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS}
-                LINK_LIBRARIES ${CMOCKA_STATIC_LIBRARY}
-                LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
 
 ### Exceptions
 
@@ -68,7 +73,7 @@
     test_assert_macros_fail
         PROPERTIES
         PASS_REGULAR_EXPRESSION
-        "\\[  FAILED  \\] 1 test"
+        "\\[  FAILED  \\] tests: 1 test"
 )
 
 # test_ordering ensure proper failures
@@ -76,7 +81,7 @@
     test_ordering_fail
         PROPERTIES
         PASS_REGULAR_EXPRESSION
-        "\\[  FAILED  \\] 7 test"
+        "\\[  FAILED  \\] tests: 7 test"
 )
 
 # test_returns_fail ensure proper failures
@@ -84,22 +89,15 @@
     test_returns_fail
         PROPERTIES
         PASS_REGULAR_EXPRESSION
-        "\\[  FAILED  \\] 3 test"
+        "\\[  FAILED  \\] alloc_tests: 3 test"
 )
 
 # test_exception_handler
 if (TEST_EXCEPTION_HANDLER)
-    if (WIN32)
-        set_tests_properties(test_exception_handler
-                                 PROPERTIES
-                                     PASS_REGULAR_EXPRESSION
-                                         "EXCEPTION_ACCESS_VIOLATION occurred at")
-    else()
-        set_tests_properties(test_exception_handler
-                             PROPERTIES
-                                 PASS_REGULAR_EXPRESSION
-                                     "Test failed with exception: (Segmentation fault|Segmentation Fault|11|Illegal instruction)")
-    endif (WIN32)
+    set_tests_properties(test_exception_handler
+                         PROPERTIES
+                             PASS_REGULAR_EXPRESSION
+                             "Test failed with exception")
 endif (TEST_EXCEPTION_HANDLER)
 
 set_tests_properties(
@@ -124,6 +122,7 @@
 )
 
 add_test(test_setup_fail_1_failed ${TARGET_SYSTEM_EMULATOR} test_setup_fail)
+add_cmocka_test_environment(test_setup_fail_1_failed)
 set_tests_properties(
     test_setup_fail_1_failed
         PROPERTIES
@@ -132,6 +131,7 @@
 )
 
 add_test (test_setup_fail_1_passed ${TARGET_SYSTEM_EMULATOR} test_setup_fail)
+add_cmocka_test_environment(test_setup_fail_1_passed)
 set_tests_properties(
     test_setup_fail_1_passed
         PROPERTIES
@@ -140,6 +140,7 @@
 )
 
 add_test (test_setup_fail_match_failed ${TARGET_SYSTEM_EMULATOR} test_setup_fail)
+add_cmocka_test_environment(test_setup_fail_match_failed)
 set_tests_properties(
     test_setup_fail_match_failed
         PROPERTIES
@@ -148,6 +149,7 @@
 )
 
 add_test (test_setup_fail_match_passed ${TARGET_SYSTEM_EMULATOR} test_setup_fail)
+add_cmocka_test_environment(test_setup_fail_match_passed)
 set_tests_properties(
     test_setup_fail_match_passed
         PROPERTIES
@@ -171,23 +173,26 @@
     xml)
 
 set(test_basics_tap_out
-    "^1\\.\\.2"
+    "^TAP version 13"
+    "1\\.\\.2"
     "ok 1 - null_test_success"
     "ok 2 - int_test_success"
     "# ok - tests")
 set(test_assert_macros_fail_tap_out
-    "^1\\.\\.1"
+    "^TAP version 13"
+    "1\\.\\.1"
     "not ok 1 - test_assert_return_code_fail"
     "#[^\n\r]+[\n\r]#[^\n\r]+[\n\r]# not ok - tests")
 set(test_groups_tap_out
-    "^1\\.\\.1"
+    "^TAP version 13"
+    "1\\.\\.1"
     "ok 1 - null_test_success"
     "# ok - test_group1"
     "1\\.\\.1"
     "ok 1 - int_test_success"
-    "# ok - test_group2")
+    "# ok - test_group2 num=<'\"2&2'\">")
 set(test_skip_tap_out
-    "not ok 1 # SKIP")
+    "ok 1 # SKIP")
 set(test_setup_fail_tap_out
     "not ok 1 - int_test_ignored Could not run test: Test setup failed")
 
@@ -218,7 +223,7 @@
     "<testcase name=\"null_test_success\" time=\"[0-9.]+\" >"
     "</testcase>"
     "</testsuite>"
-    ".*<testsuite name=\"test_group2\" time=\"[0-9.]+\" tests=\"1\" failures=\"0\" errors=\"0\" skipped=\"0\" >"
+    ".*<testsuite name=\"test_group2 num=&lt[;]&apos[;]&quot[;]2&amp[;]2&apos[;]&quot[;]&gt[;]\" time=\"[0-9.]+\" tests=\"1\" failures=\"0\" errors=\"0\" skipped=\"0\" >"
     "<testcase name=\"int_test_success\" time=\"[0-9.]+\" >"
     "</testcase>"
     "</testsuite>"
@@ -234,10 +239,12 @@
     foreach(_OUTPUT_TEST ${OUTPUT_TESTS})
         set(TEST_NAME ${_OUTPUT_TEST}_${_TEST_OUTPUT_FMT})
         add_test(${TEST_NAME} ${TARGET_SYSTEM_EMULATOR} ${_OUTPUT_TEST})
+        add_cmocka_test_environment(${TEST_NAME})
 
         set_property(
             TEST
             ${TEST_NAME}
+            APPEND
             PROPERTY
                 ENVIRONMENT CMOCKA_MESSAGE_OUTPUT=${_TEST_OUTPUT_FMT}
             )

=== debian/changelog ===
cmocka (1.1.8-1) experimental; urgency=medium

  * Upload to experimental during the freeze

  [ Alexander Dahl ]
  * tests: Add test for test_calloc()
  * cmocka: Add overflow check for test_calloc()
  * cmake: Set CMOCKA_LIBRARIES in package config for backwards compatibility

  [ Jakub Czapiga ]
  * Improve c_strreplace implementation
  * Sanitize XML strings.

  [ Alois Klink ]
  * cmake: disable `-Wdeclaration-after-statement`

  [ Joseph Sutton ]
  * cmocka: Fix assert_memory_equal() display

  [ Andreas Schneider ]
  * doc: Fix pre-defined macro definition
  * tests: Add missing stdint.h
  * Update check for uintptr_t
  * cmake: Require at least version 3.10
  * Bump version to 1.1.8

  [ Yegor Yefremov ]
  * CMakeLists.txt: remove an obsolete policy

  [ David Prévot ]
  * Update Standards-Version to 4.7.2

 -- David Prévot <taffit@debian.org>  Sun, 20 Jul 2025 17:26:04 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: David Prévot <taffit@debian.org>
 Uploaders: Sandro Knauß <hefee@debian.org>
 Build-Depends: cmake, debhelper-compat (= 13)
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://cmocka.org/
 Vcs-Git: https://salsa.debian.org/debian/cmocka.git
 Vcs-Browser: https://salsa.debian.org/debian/cmocka

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
